grammar debugMeWithAntlrWorks;
 options{backtrack=true; memoize=true;} 



parse :
	 result=rulegraphvizmodel
	 // Always return the root node! This prevents that this method is called multiple times
	 // with interesting side effects.
	 EOF
;

rulegraphvizmodel 

:
(rulegraph)*
;

rulegraph 

:
(('strict')?

(rulegraphtype)

(RULE_DOT_ID)?

(ruleattr_list)*

('{')

(rulestmt)*

('}')
)
;

rulestmt 

:
(((temp_edge_stmt_node=ruleedge_stmt_node)
	|
(temp_edge_stmt_subgraph=ruleedge_stmt_subgraph)
	|
(temp_node_stmt=rulenode_stmt)
	|
(temp_attribute=ruleattribute)
	|
(temp_attr_stmt=ruleattr_stmt)
	|
(temp_subgraph=rulesubgraph)
)

(';')?
)
;

ruleedge_stmt_node 

:
((rulenode_id)

(ruleedgeRHS)+

(ruleattr_list)*
)
;

ruleedge_stmt_subgraph 

:
((rulesubgraph)

(ruleedgeRHS)+

(ruleattr_list)*
)
;

rulenode_stmt 

:
((RULE_DOT_ID)

(ruleport)?

(ruleattr_list)*
)
;

ruleattribute 

:
((RULE_DOT_ID)

('=')

(RULE_DOT_ID)
)
;

ruleattr_stmt 

:
((ruleattributetype)

(ruleattr_list)+
)
;

ruleattr_list 

:
(('[')

(rulea_list)*

(']')
)
;

rulea_list 

:
((RULE_DOT_ID)

(('=')

(RULE_DOT_ID)
)?

(',')?
)
;

rulesubgraph 

:
((('subgraph')

(RULE_DOT_ID)
)?

(ruleattr_list)*

('{')

(rulestmt)*

('}')
)
;

ruleport 

:
(((':')

(RULE_DOT_ID)

((':')

(rulecompass_pt)
)?
)
	|
((':')

(rulecompass_pt)
)
)
;

ruleedgeRHS 
:
        temp_edgerhs_node=ruleedgeRHS_node 	|        temp_edgerhs_subgraph=ruleedgeRHS_subgraph 	;

ruleedgeRHS_node 

:
((ruleedgeop)

(rulenode_id)
)
;

ruleedgeRHS_subgraph 

:
((ruleedgeop)

(rulesubgraph)
)
;

rulenode_id 

:
((RULE_DOT_ID)

(ruleport)?
)
;

ruleedgeop  :
		 '->'
		 
	 |		 '--'
		 
;

rulegraphtype  :
		 'graph'
		 
	 |		 'digraph'
		 
;

ruleattributetype  :
		 'graph'
		 
	 |		 'node'
		 
	 |		 'edge'
		 
;

rulecompass_pt  :
		 'n'
		 
	 |		 'ne'
		 
	 |		 'e'
		 
	 |		 'se'
		 
	 |		 's'
		 
	 |		 'sw'
		 
	 |		 'w'
		 
	 |		 'nw'
		 
;

RULE_DOT_ID :

	 (('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*) |
	('"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\') | ~('"') )* '"') |
	(('-')?('.'('0'..'9')+ | ('0'..'9')+('.' ('0'..'9')*)? ))
;

RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

RULE_STRING :

	 '\"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\"') )* '\"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

RULE_INT :

	 ('-')?('0'..'9')+
	 
;

RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

