/*
 * <copyright>
 *
 * Copyright (c) 2005-2006 Sven Efftinge (http://www.efftinge.de) and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Sven Efftinge (http://www.efftinge.de) - Initial API and implementation
 *
 * </copyright>
 */
package org.openarchitectureware.core;

import org.eclipse.core.resources.IStorage;
import org.openarchitectureware.expression.Resource;

public interface IOawResource extends Resource {

    public IStorage getUnderlyingStorage();

    /**
     * analyzes the underlying AST and adds respective markers to the
     * underlying IFile (getCorrspondingFile())
     */
    public void analyze();

    /**
     * updates the underlying AST
     * @return true if the source could be parsed and an AST is available
     */
    public boolean refresh();

    /**
     * returns the root element of the AST
     * @return
     */
	public Resource getOawResource();
	
	public String getFileExtension();
}
