/*
 * <copyright>
 *
 * Copyright (c) 2005-2006 Sven Efftinge (http://www.efftinge.de) and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Sven Efftinge (http://www.efftinge.de) - Initial API and implementation
 *
 * </copyright>
 */
package org.openarchitectureware.expression.ast;

import java.util.Set;

import org.openarchitectureware.expression.AnalysationIssue;
import org.openarchitectureware.expression.ExecutionContext;
import org.openarchitectureware.type.Type;

/**
 * @author Sven Efftinge (http://www.efftinge.de)
 * @author Arno Haase
 */
public class RealLiteral extends Literal {

    public RealLiteral(final Identifier literalValue) {
        super(literalValue);
    }

    @Override
    protected Object evaluateInternal(final ExecutionContext ctx) {
        return new Double(getLiteralValue().getValue());
    }

    public Type analyzeInternal(final ExecutionContext ctx, final Set<AnalysationIssue> issues) {
        return ctx.getRealType();
    }

}
