grammar dot;
 options{backtrack=true; memoize=true;} 

@lexer::header {
package org.openarchitectureware.graphviz.parser;

import org.openarchitectureware.xtext.parser.ErrorMsg;
import org.openarchitectureware.xtext.parser.impl.AntlrUtil;

}

@parser::header {
package org.openarchitectureware.graphviz.parser;

import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.emf.ecore.EObject;

import org.openarchitectureware.xtext.parser.impl.AntlrUtil;
import org.openarchitectureware.xtext.XtextFile;
import org.openarchitectureware.xtext.parser.impl.EcoreModelFactory;
import org.openarchitectureware.xtext.parser.ErrorMsg;
import org.openarchitectureware.xtext.parser.model.ParseTreeManagerNeu;
import org.openarchitectureware.xtext.parser.parsetree.Node;

import org.openarchitectureware.graphviz.MetaModelRegistration;

}
@lexer::members {
	 private List<ErrorMsg> errors = new ArrayList<ErrorMsg>();
	public List<ErrorMsg> getErrors() {
		return errors;
	}

	public String getErrorMessage(RecognitionException e, String[] tokenNames) {
		String msg = super.getErrorMessage(e,tokenNames);
		errors.add(AntlrUtil.create(msg,e,tokenNames));
		return msg;
	}
}

@parser::members {

	private Token getLastToken() {
		return input.LT(-1);
	}

	protected Object convert(Object arg) {
		if (arg instanceof org.antlr.runtime.Token) {
			Token t = (Token) arg;
			String s = t.getText();
			if (t.getType() == dotLexer.RULE_ID && s.startsWith("^")) {
				return s.substring(1);
			} else if (t.getType()==dotLexer.RULE_STRING) {
				return s.substring(1,s.length()-1);
			} else if (t.getType()==dotLexer.RULE_INT) {
				return Integer.valueOf(s);
			}
			return s;
		}
		return arg;
	}


	private EcoreModelFactory factory = new EcoreModelFactory(MetaModelRegistration.getEPackage());
    private ParseTreeManagerNeu ptm = new ParseTreeManagerNeu();
	private XtextFile xtextfile = MetaModelRegistration.getXtextFile();
	
	{
		
	}

	public ParseTreeManagerNeu getResult() {
		return ptm;
	}

	private List<ErrorMsg> errors = new ArrayList<ErrorMsg>();
	public List<ErrorMsg> getErrors() {
		return errors;
	}

	@Override
	public void reportError(RecognitionException e) {
		String msg = super.getErrorMessage(e,tokenNames);
		errors.add(AntlrUtil.create(msg,e,tokenNames));
		ptm.addError(msg, e);
		// This doesn't work. ANTLR may simply report an superfluous token. In that case,
		// two nodes will be finished instead of one.
		// ptm.ruleFinished(null, end());
	}

    private boolean skipCurrentToken;
    
	@Override
	protected boolean recoverFromMismatchedElement(IntStream arg0, RecognitionException arg1, BitSet arg2) {
		skipCurrentToken = true;
		return super.recoverFromMismatchedElement(arg0, arg1, arg2);
	}
}


parse returns [Node r]:
	 result=rulegraphvizmodel
	 // Always return the root node! This prevents that this method is called multiple times
	 // with interesting side effects.
{
if (result != null)
  ptm.setModelElement(result);
$r = ptm.getCurrent();
ptm.ruleFinished(result);}	 EOF
;

rulegraphvizmodel returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "graphvizmodel");
			 }
({ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(0)).eContents().get(1)));}temp_graph=
rulegraph{if (temp_graph != null) {
  hasContent = true;
  ptm.setModelElement(temp_graph);
  factory.add($result,"graphs",convert(temp_graph),false);
  ptm.ruleFinished(temp_graph);
} else {
  ptm.destroyNode();
}
}
)*
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulegraph returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "graph");
			 }
(({skipCurrentToken = false;}
'strict'{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(0)));
  factory.set($result,"strict",true);
  ptm.ruleFinished(temp);
}}
)?

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(1)));}temp_graphtype=
rulegraphtype{if (temp_graphtype != null) {
  hasContent = true;
  factory.set($result,"type",convert(temp_graphtype),false);
  ptm.ruleFinished(temp_graphtype);
} else {
  ptm.destroyNode();
}
}
)

({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(2)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)?

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(3)));}temp_attr_list=
ruleattr_list{if (temp_attr_list != null) {
  hasContent = true;
  ptm.setModelElement(temp_attr_list);
  factory.add($result,"attributes",convert(temp_attr_list),false);
  ptm.ruleFinished(temp_attr_list);
} else {
  ptm.destroyNode();
}
}
)*

({skipCurrentToken = false;}'{'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(5)));}temp_stmt=
rulestmt{if (temp_stmt != null) {
  hasContent = true;
  ptm.setModelElement(temp_stmt);
  factory.add($result,"stmts",convert(temp_stmt),false);
  ptm.ruleFinished(temp_stmt);
} else {
  ptm.destroyNode();
}
}
)*

({skipCurrentToken = false;}'}'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(1)).eContents().get(1)).eContents().get(6)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulestmt returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "stmt");
			 }
((({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(2)).eContents().get(1)).eContents().get(0)).eContents().get(0)));}
temp_edge_stmt_node=ruleedge_stmt_node
{if (temp_edge_stmt_node != null) {
  hasContent = true;
  ptm.setModelElement(temp_edge_stmt_node);
  ptm.ruleFinished(temp_edge_stmt_node);
  $result=temp_edge_stmt_node;
} else {
  ptm.destroyNode();
}
}
)
	|
({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(2)).eContents().get(1)).eContents().get(0)).eContents().get(1)));}
temp_edge_stmt_subgraph=ruleedge_stmt_subgraph
{if (temp_edge_stmt_subgraph != null) {
  hasContent = true;
  ptm.setModelElement(temp_edge_stmt_subgraph);
  ptm.ruleFinished(temp_edge_stmt_subgraph);
  $result=temp_edge_stmt_subgraph;
} else {
  ptm.destroyNode();
}
}
)
	|
({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(2)).eContents().get(1)).eContents().get(0)).eContents().get(2)));}
temp_node_stmt=rulenode_stmt
{if (temp_node_stmt != null) {
  hasContent = true;
  ptm.setModelElement(temp_node_stmt);
  ptm.ruleFinished(temp_node_stmt);
  $result=temp_node_stmt;
} else {
  ptm.destroyNode();
}
}
)
	|
({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(2)).eContents().get(1)).eContents().get(0)).eContents().get(3)));}
temp_attribute=ruleattribute
{if (temp_attribute != null) {
  hasContent = true;
  ptm.setModelElement(temp_attribute);
  ptm.ruleFinished(temp_attribute);
  $result=temp_attribute;
} else {
  ptm.destroyNode();
}
}
)
	|
({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(2)).eContents().get(1)).eContents().get(0)).eContents().get(4)));}
temp_attr_stmt=ruleattr_stmt
{if (temp_attr_stmt != null) {
  hasContent = true;
  ptm.setModelElement(temp_attr_stmt);
  ptm.ruleFinished(temp_attr_stmt);
  $result=temp_attr_stmt;
} else {
  ptm.destroyNode();
}
}
)
	|
({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(2)).eContents().get(1)).eContents().get(0)).eContents().get(5)));}
temp_subgraph=rulesubgraph
{if (temp_subgraph != null) {
  hasContent = true;
  ptm.setModelElement(temp_subgraph);
  ptm.ruleFinished(temp_subgraph);
  $result=temp_subgraph;
} else {
  ptm.destroyNode();
}
}
)
)

({skipCurrentToken = false;}';'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(2)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})?
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleedge_stmt_node returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "edge_stmt_node");
			 }
(({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(3)).eContents().get(1)).eContents().get(0)));}temp_node_id=
rulenode_id{if (temp_node_id != null) {
  hasContent = true;
  ptm.setModelElement(temp_node_id);
  factory.set($result,"node_id",convert(temp_node_id),false);
  ptm.ruleFinished(temp_node_id);
} else {
  ptm.destroyNode();
}
}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(3)).eContents().get(1)).eContents().get(1)));}temp_edgeRHS=
ruleedgeRHS{if (temp_edgeRHS != null) {
  hasContent = true;
  ptm.setModelElement(temp_edgeRHS);
  factory.add($result,"edgeRHS",convert(temp_edgeRHS),false);
  ptm.ruleFinished(temp_edgeRHS);
} else {
  ptm.destroyNode();
}
}
)+

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(3)).eContents().get(1)).eContents().get(2)));}temp_attr_list=
ruleattr_list{if (temp_attr_list != null) {
  hasContent = true;
  ptm.setModelElement(temp_attr_list);
  factory.add($result,"attributes",convert(temp_attr_list),false);
  ptm.ruleFinished(temp_attr_list);
} else {
  ptm.destroyNode();
}
}
)*
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleedge_stmt_subgraph returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "edge_stmt_subgraph");
			 }
(({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(0)));}temp_subgraph=
rulesubgraph{if (temp_subgraph != null) {
  hasContent = true;
  ptm.setModelElement(temp_subgraph);
  factory.set($result,"subgraph",convert(temp_subgraph),false);
  ptm.ruleFinished(temp_subgraph);
} else {
  ptm.destroyNode();
}
}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(1)));}temp_edgeRHS=
ruleedgeRHS{if (temp_edgeRHS != null) {
  hasContent = true;
  ptm.setModelElement(temp_edgeRHS);
  factory.set($result,"edgeRHS",convert(temp_edgeRHS),false);
  ptm.ruleFinished(temp_edgeRHS);
} else {
  ptm.destroyNode();
}
}
)+

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(4)).eContents().get(1)).eContents().get(2)));}temp_attr_list=
ruleattr_list{if (temp_attr_list != null) {
  hasContent = true;
  ptm.setModelElement(temp_attr_list);
  factory.add($result,"attributes",convert(temp_attr_list),false);
  ptm.ruleFinished(temp_attr_list);
} else {
  ptm.destroyNode();
}
}
)*
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulenode_stmt returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "node_stmt");
			 }
(({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(5)).eContents().get(1)).eContents().get(0)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(5)).eContents().get(1)).eContents().get(1)));}temp_port=
ruleport{if (temp_port != null) {
  hasContent = true;
  ptm.setModelElement(temp_port);
  factory.set($result,"port",convert(temp_port),false);
  ptm.ruleFinished(temp_port);
} else {
  ptm.destroyNode();
}
}
)?

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(5)).eContents().get(1)).eContents().get(2)));}temp_attr_list=
ruleattr_list{if (temp_attr_list != null) {
  hasContent = true;
  ptm.setModelElement(temp_attr_list);
  factory.add($result,"attributes",convert(temp_attr_list),false);
  ptm.ruleFinished(temp_attr_list);
} else {
  ptm.destroyNode();
}
}
)*
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleattribute returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "attribute");
			 }
(({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(6)).eContents().get(1)).eContents().get(0)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

({skipCurrentToken = false;}'='{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(6)).eContents().get(1)).eContents().get(1)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(6)).eContents().get(1)).eContents().get(2)));
  factory.set($result,"value",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleattr_stmt returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "attr_stmt");
			 }
(({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(7)).eContents().get(1)).eContents().get(0)));}temp_attributetype=
ruleattributetype{if (temp_attributetype != null) {
  hasContent = true;
  factory.set($result,"type",convert(temp_attributetype),false);
  ptm.ruleFinished(temp_attributetype);
} else {
  ptm.destroyNode();
}
}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(7)).eContents().get(1)).eContents().get(1)));}temp_attr_list=
ruleattr_list{if (temp_attr_list != null) {
  hasContent = true;
  ptm.setModelElement(temp_attr_list);
  factory.add($result,"attributes",convert(temp_attr_list),false);
  ptm.ruleFinished(temp_attr_list);
} else {
  ptm.destroyNode();
}
}
)+
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleattr_list returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "attr_list");
			 }
(({skipCurrentToken = false;}'['{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(8)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(8)).eContents().get(1)).eContents().get(1)));}temp_a_list=
rulea_list{if (temp_a_list != null) {
  hasContent = true;
  ptm.setModelElement(temp_a_list);
  factory.add($result,"a_list",convert(temp_a_list),false);
  ptm.ruleFinished(temp_a_list);
} else {
  ptm.destroyNode();
}
}
)*

({skipCurrentToken = false;}']'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(8)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulea_list returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "a_list");
			 }
(({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(0)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

(({skipCurrentToken = false;}'='{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(1)).eContents().get(1)));
  factory.set($result,"value",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)
)?

({skipCurrentToken = false;}','{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(9)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})?
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulesubgraph returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "subgraph");
			 }
((({skipCurrentToken = false;}'subgraph'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(0)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(0)).eContents().get(1)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)
)?

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(1)));}temp_attr_list=
ruleattr_list{if (temp_attr_list != null) {
  hasContent = true;
  ptm.setModelElement(temp_attr_list);
  factory.add($result,"attributes",convert(temp_attr_list),false);
  ptm.ruleFinished(temp_attr_list);
} else {
  ptm.destroyNode();
}
}
)*

({skipCurrentToken = false;}'{'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(2)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(3)));}temp_stmt=
rulestmt{if (temp_stmt != null) {
  hasContent = true;
  ptm.setModelElement(temp_stmt);
  factory.add($result,"stmts",convert(temp_stmt),false);
  ptm.ruleFinished(temp_stmt);
} else {
  ptm.destroyNode();
}
}
)*

({skipCurrentToken = false;}'}'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(10)).eContents().get(1)).eContents().get(4)));
  ptm.ruleFinished(getLastToken());
}})
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleport returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "port");
			 }
((({skipCurrentToken = false;}':'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(0)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(0)).eContents().get(1)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

(({skipCurrentToken = false;}':'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(0)).eContents().get(2)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(0)).eContents().get(2)).eContents().get(1)));}temp_compass_pt=
rulecompass_pt{if (temp_compass_pt != null) {
  hasContent = true;
  factory.set($result,"compass_pt",convert(temp_compass_pt),false);
  ptm.ruleFinished(temp_compass_pt);
} else {
  ptm.destroyNode();
}
}
)
)?
)
	|
(({skipCurrentToken = false;}':'{if (!skipCurrentToken) {
  hasContent = true;
  ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(1)).eContents().get(0)));
  ptm.ruleFinished(getLastToken());
}})

({ptm.createNode(((EObject)((EObject)((EObject)((EObject)xtextfile.eContents().get(11)).eContents().get(1)).eContents().get(1)).eContents().get(1)));}temp_compass_pt=
rulecompass_pt{if (temp_compass_pt != null) {
  hasContent = true;
  factory.set($result,"compass_pt",convert(temp_compass_pt),false);
  ptm.ruleFinished(temp_compass_pt);
} else {
  ptm.destroyNode();
}
}
)
)
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleedgeRHS returns [EObject result]
:
        temp_edgerhs_node=ruleedgeRHS_node {$result=temp_edgerhs_node;}	|        temp_edgerhs_subgraph=ruleedgeRHS_subgraph {$result=temp_edgerhs_subgraph;}	;

ruleedgeRHS_node returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "edgeRHS_node");
			 }
(({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(13)).eContents().get(1)).eContents().get(0)));}temp_edgeop=
ruleedgeop{if (temp_edgeop != null) {
  hasContent = true;
  factory.set($result,"op",convert(temp_edgeop),false);
  ptm.ruleFinished(temp_edgeop);
} else {
  ptm.destroyNode();
}
}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(13)).eContents().get(1)).eContents().get(1)));}temp_node_id=
rulenode_id{if (temp_node_id != null) {
  hasContent = true;
  ptm.setModelElement(temp_node_id);
  factory.set($result,"node",convert(temp_node_id),false);
  ptm.ruleFinished(temp_node_id);
} else {
  ptm.destroyNode();
}
}
)
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleedgeRHS_subgraph returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "edgeRHS_subgraph");
			 }
(({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(14)).eContents().get(1)).eContents().get(0)));}temp_edgeop=
ruleedgeop{if (temp_edgeop != null) {
  hasContent = true;
  factory.set($result,"op",convert(temp_edgeop),false);
  ptm.ruleFinished(temp_edgeop);
} else {
  ptm.destroyNode();
}
}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(14)).eContents().get(1)).eContents().get(1)));}temp_subgraph=
rulesubgraph{if (temp_subgraph != null) {
  hasContent = true;
  ptm.setModelElement(temp_subgraph);
  factory.set($result,"subgraph",convert(temp_subgraph),false);
  ptm.ruleFinished(temp_subgraph);
} else {
  ptm.destroyNode();
}
}
)
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

rulenode_id returns [EObject result]
@init {boolean hasContent = false;}
:
			{
				$result = factory.create("", "node_id");
			 }
(({skipCurrentToken = false;}
RULE_DOT_ID{if (!skipCurrentToken) {
  hasContent = true;
  Token temp = getLastToken();
  ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(15)).eContents().get(1)).eContents().get(0)));
  factory.set($result,"name",convert(temp),false);
  ptm.ruleFinished(temp);
}}
)

({ptm.createNode(((EObject)((EObject)((EObject)xtextfile.eContents().get(15)).eContents().get(1)).eContents().get(1)));}temp_port=
ruleport{if (temp_port != null) {
  hasContent = true;
  ptm.setModelElement(temp_port);
  factory.set($result,"port",convert(temp_port),false);
  ptm.ruleFinished(temp_port);
} else {
  ptm.destroyNode();
}
}
)?
)
 {if (!hasContent)
  $result = null;};
catch [RecognitionException re] {if (!hasContent)
    $result = null;
reportError(re);
recover(input,re);}

ruleedgeop returns [Enumerator r] :
		 '->'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(16)).eContents().get(1)));
$r=factory.enumLit("", "edgeop","directed");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 '--'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(16)).eContents().get(2)));
$r=factory.enumLit("", "edgeop","undirected");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
;

rulegraphtype returns [Enumerator r] :
		 'graph'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(17)).eContents().get(1)));
$r=factory.enumLit("", "graphtype","graph");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'digraph'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(17)).eContents().get(2)));
$r=factory.enumLit("", "graphtype","digraph");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
;

ruleattributetype returns [Enumerator r] :
		 'graph'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(18)).eContents().get(1)));
$r=factory.enumLit("", "attributetype","graph");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'node'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(18)).eContents().get(2)));
$r=factory.enumLit("", "attributetype","node");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'edge'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(18)).eContents().get(3)));
$r=factory.enumLit("", "attributetype","edge");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
;

rulecompass_pt returns [Enumerator r] :
		 'n'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(19)).eContents().get(1)));
$r=factory.enumLit("", "compass_pt","north");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'ne'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(19)).eContents().get(2)));
$r=factory.enumLit("", "compass_pt","northeast");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'e'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(19)).eContents().get(3)));
$r=factory.enumLit("", "compass_pt","east");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'se'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(19)).eContents().get(4)));
$r=factory.enumLit("", "compass_pt","southeast");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 's'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(19)).eContents().get(5)));
$r=factory.enumLit("", "compass_pt","south");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'sw'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(19)).eContents().get(6)));
$r=factory.enumLit("", "compass_pt","southwest");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'w'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(19)).eContents().get(7)));
$r=factory.enumLit("", "compass_pt","west");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
	 |		 'nw'
		 {ptm.createNode(((EObject)((EObject)xtextfile.eContents().get(19)).eContents().get(8)));
$r=factory.enumLit("", "compass_pt","northwest");
ptm.setModelElement($r);
ptm.ruleFinished(getLastToken());
}
;

RULE_DOT_ID :

	 (('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*) |
	('"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\') | ~('"') )* '"') |
	(('-')?('.'('0'..'9')+ | ('0'..'9')+('.' ('0'..'9')*)? ))
;

RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

RULE_STRING :

	 '\"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\"') )* '\"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

RULE_INT :

	 ('-')?('0'..'9')+
	 
;

RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

