lexer grammar dot;
@members {
	 private List<ErrorMsg> errors = new ArrayList<ErrorMsg>();
	public List<ErrorMsg> getErrors() {
		return errors;
	}

	public String getErrorMessage(RecognitionException e, String[] tokenNames) {
		String msg = super.getErrorMessage(e,tokenNames);
		errors.add(AntlrUtil.create(msg,e,tokenNames));
		return msg;
	}
}
@header {
package org.openarchitectureware.graphviz.parser;

import org.openarchitectureware.xtext.parser.ErrorMsg;
import org.openarchitectureware.xtext.parser.impl.AntlrUtil;

}

T11 : 'strict' ;
T12 : '{' ;
T13 : '}' ;
T14 : ';' ;
T15 : '=' ;
T16 : '[' ;
T17 : ']' ;
T18 : ',' ;
T19 : 'subgraph' ;
T20 : ':' ;
T21 : '->' ;
T22 : '--' ;
T23 : 'graph' ;
T24 : 'digraph' ;
T25 : 'node' ;
T26 : 'edge' ;
T27 : 'n' ;
T28 : 'ne' ;
T29 : 'e' ;
T30 : 'se' ;
T31 : 's' ;
T32 : 'sw' ;
T33 : 'w' ;
T34 : 'nw' ;

// $ANTLR src "..//org.openarchitectureware.graphviz/_src-gen/org/openarchitectureware/graphviz/parser/dot.g" 962
RULE_DOT_ID :

	 (('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*) |
	('"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'"'|'\''|'\\') | ~('"') )* '"') |
	(('-')?('.'('0'..'9')+ | ('0'..'9')+('.' ('0'..'9')*)? ))
;

// $ANTLR src "..//org.openarchitectureware.graphviz/_src-gen/org/openarchitectureware/graphviz/parser/dot.g" 969
RULE_ID :

	 ('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
	 
;

// $ANTLR src "..//org.openarchitectureware.graphviz/_src-gen/org/openarchitectureware/graphviz/parser/dot.g" 975
RULE_STRING :

	 '\"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\"') )* '\"' |
	 '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\''
	 
;

// $ANTLR src "..//org.openarchitectureware.graphviz/_src-gen/org/openarchitectureware/graphviz/parser/dot.g" 982
RULE_INT :

	 ('-')?('0'..'9')+
	 
;

// $ANTLR src "..//org.openarchitectureware.graphviz/_src-gen/org/openarchitectureware/graphviz/parser/dot.g" 988
RULE_WS :

	 (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;}
	 
;

// $ANTLR src "..//org.openarchitectureware.graphviz/_src-gen/org/openarchitectureware/graphviz/parser/dot.g" 994
RULE_ML_COMMENT :

	 '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
	 
;

// $ANTLR src "..//org.openarchitectureware.graphviz/_src-gen/org/openarchitectureware/graphviz/parser/dot.g" 1000
RULE_SL_COMMENT :

	 '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
	 
;

