/*
 * <copyright>
 *
 * Copyright (c) 2005-2006 Sven Efftinge (http://www.efftinge.de) and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     Sven Efftinge (http://www.efftinge.de) - Initial API and implementation
 *
 * </copyright>
 */
package org.openarchitectureware.workflow.issues;

import org.openarchitectureware.workflow.WorkflowComponent;

/**
 * Collects information about workflow configuration.
 * 
 * @author Sven Efftinge (http://www.efftinge.de)
 * @since 4.0
 */
public interface Issues {
    /**
     * Adds a warn message.
     * 
     * @param msg
     *            Message text.
     */
    public void addWarning(String msg);

    /**
     * Adds an error message.
     * 
     * @param msg
     *            Message text.
     */
    public void addError(String msg);

    /**
     * Adds a warn message.
     * 
     * @param msg
     *            Message text.
     */
    public void addWarning(String msg, Object obj);

    /**
     * Adds an error message.
     * 
     * @param msg
     *            Message text.
     */
    public void addError(String msg, Object obj);

    /**
     * Adds a warn message.
     * 
     * @param msg
     *            Message text.
     */
    public void addWarning(WorkflowComponent ctx, String msg, Object obj);

    /**
     * Adds an error message.
     * 
     * @param msg
     *            Message text.
     */
    public void addError(WorkflowComponent ctx, String msg, Object obj);

    /**
     * Adds a warn message.
     * 
     * @param msg
     *            Message text.
     */
    public void addWarning(WorkflowComponent ctx, String msg);

    /**
     * Adds an error message.
     * 
     * @param msg
     *            Message text.
     */
    public void addError(WorkflowComponent ctx, String msg);

    public Issue[] getErrors();

    public Issue[] getWarnings();

    public boolean hasErrors();
    
    /**
     * removes all warnings and errors
     */
    public void clear();
}
