/*******************************************************************************
 * Copyright (c) 2005 - 2008 committers of openArchitectureWare and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare - initial API and implementation
 *******************************************************************************/
package org.openarchitectureware.xsd.type;

import org.eclipse.emf.ecore.EStructuralFeature;
import org.openarchitectureware.expression.TypeSystem;
import org.openarchitectureware.type.AbstractTypeImpl;
import org.openarchitectureware.type.Feature;
import org.openarchitectureware.type.baseimpl.OperationImpl;
import org.openarchitectureware.type.baseimpl.PropertyImpl;

/**
 * @author Moritz Eysholdt
 */
public class EFeatureType extends AbstractTypeImpl {

	public EFeatureType(TypeSystem typeSystem, String name) {
		super(typeSystem, name);
	}

	public Feature[] getContributedFeatures() {
		return new Feature[] {
				new PropertyImpl(this, "name", getTypeSystem().getStringType()) {
					public Object get(Object target) {
						EStructuralFeature f = (EStructuralFeature) target;
						return f.getName();
					}
				},
				new OperationImpl(this, "toString", getTypeSystem()
						.getStringType()) {
					protected Object evaluateInternal(Object target,
							Object[] params) {
						EStructuralFeature f = (EStructuralFeature) target;
						return f.getName();
					}
				} };
	}

	public boolean isInstance(Object o) {
		return o instanceof EStructuralFeature;
	}

	public Object newInstance() {
		throw new UnsupportedOperationException(
				"EFeatures can not be instantiated manually");
	}

}
