/*******************************************************************************
 * Copyright (c) 2007 Sven Efftinge (http://www.efftinge.de) and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     committers of openArchitectureWare
 *******************************************************************************/
 
 package org.openarchitectureware.xtext.editor.scanning;

import org.eclipse.jface.text.rules.IRule;
import org.eclipse.jface.text.rules.WhitespaceRule;
import org.openarchitectureware.xtext.AbstractXtextEditorPlugin;
import org.openarchitectureware.xtext.editor.AbstractXtextEditor;

/**
 * @author Sven Efftinge (http://www.efftinge.de)
 * 
 * 
 */
public class ContentScanner extends AbstractRuleBasedScanner {

    public ContentScanner(AbstractXtextEditorPlugin plugin, AbstractXtextEditor editor) {
        super(plugin);
        IRule[] rules = new IRule[3];
        // Add generic whitespace rule.
        rules[0] = new WhitespaceRule(new WhitespaceDetector());
        rules[1] = new ContextKeywordRule(keyword, plugin.getUtilities().allKeywords(), editor,  plugin);
        rules[2] = new KeywordRule(keyword, plugin.getUtilities().allKeywords());
        setRules(rules);
        setDefaultReturnToken(other);
    }
    
}