lexer grammar XText;
@members {
   private List<ErrorMsg> errors = new ArrayList<ErrorMsg>();
	public List<ErrorMsg> getErrors() {
		return errors;
	}
	
	public String getErrorMessage(RecognitionException e, String[] tokenNames) { 
		String msg = super.getErrorMessage(e,tokenNames);
		errors.add(AntlrUtil.create(msg,e,tokenNames));
		return msg; 
	} 
}
@header {
package org.openarchitectureware.xtext.parser.antlr; 

import java.util.ArrayList;
import java.util.List;

import org.antlr.runtime.CharStream;
import org.antlr.runtime.EarlyExitException;
import org.antlr.runtime.Lexer;
import org.antlr.runtime.MismatchedSetException;
import org.antlr.runtime.NoViableAltException;
import org.antlr.runtime.RecognitionException;
import org.openarchitectureware.xtext.parser.ErrorMsg;
import org.openarchitectureware.xtext.parser.impl.AntlrUtil;
}

T10 : 'grammar_name' ;
T11 : 'grammar_nsURI' ;
T12 : 'preventMMGeneration' ;
T13 : 'commentsDisabled' ;
T14 : 'importGrammar' ;
T15 : 'importMetamodel' ;
T16 : 'as' ;
T17 : ';' ;
T18 : 'Native' ;
T19 : ':' ;
T20 : '[' ;
T21 : ']' ;
T22 : '::' ;
T23 : 'String' ;
T24 : 'Enum' ;
T25 : '|' ;
T26 : '=' ;
T27 : '(' ;
T28 : ')' ;
T29 : 'URI' ;
T30 : '?=' ;
T31 : '+=' ;
T32 : '?' ;
T33 : '*' ;
T34 : '+' ;

// $ANTLR src "/Users/user/Documents/workspace/ws-apg-prototype/xtext.core/bin/XText.g" 334
STRING :  
    '"' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'"') )* '"' |
    '\'' ( '\\' ('b'|'t'|'n'|'f'|'r'|'\"'|'\''|'\\') | ~('\\'|'\'') )* '\'';

// $ANTLR src "/Users/user/Documents/workspace/ws-apg-prototype/xtext.core/bin/XText.g" 338
ID	:
	('^')?('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'_'|'0'..'9')*
;

// $ANTLR src "/Users/user/Documents/workspace/ws-apg-prototype/xtext.core/bin/XText.g" 342
XTEXT_INT :
	('0'..'9')+ 
;

// $ANTLR src "/Users/user/Documents/workspace/ws-apg-prototype/xtext.core/bin/XText.g" 346
XTEXT_ML_COMMENT
    :   '/*' ( options {greedy=false;} : . )* '*/' {$channel=HIDDEN;}
    ;

// $ANTLR src "/Users/user/Documents/workspace/ws-apg-prototype/xtext.core/bin/XText.g" 350
XTEXT_SL_COMMENT
    : '//' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
    ;

// $ANTLR src "/Users/user/Documents/workspace/ws-apg-prototype/xtext.core/bin/XText.g" 354
XTEXT_WS : (' '|'\t'|'\r'|'\n')+ {$channel=HIDDEN;} ; 
